<?php
   /*
    *  Change Pass
    *
    */

   chdir ("..");
   session_start();

   if (!isset($config_php))
      include ("../config/config.php");
   if (!isset($strings_php))
      include ("../functions/strings.php");
   if (!isset($page_header))
      include ("../functions/page_header.php");
   if (!isset($imap_php))
      include ("../functions/imap.php");

   if (isset($plugin_change_ldappass))
       $Messages = change_ldappass_check();

   include ("../src/load_prefs.php");
   displayPageHeader($color, "None");

//   global $PHP_SELF;

?>

<br>
<table width=95% align=center cellpadding=2 cellspacing=2 border=0>
<tr><td bgcolor="<?php echo $color[0] ?>">
   <center><b>Change Password</b></center>
</td><?php

if (isset($Messages) && count($Messages)) {
    echo "<tr><td>\n";
    foreach ($Messages as $line) {
        echo htmlspecialchars($line) . "<br>\n";
    }
    echo "</td></tr>\n";
}

?><tr><td>
    <form method=post action="<?php print $PHP_SELF ?>">
    <table>
      <tr>
        <th align=right>Old Password:</th>
        <td><input type=password name=cp_oldpass value=""  size=20></td>
      </tr>
      <tr>
        <th align=right>New Password:</th>
        <td><input type=password name=cp_newpass value="" size=20></td>
      </tr>
      <tr>
        <th align=right>Verify New Password:</th>
        <td><input type=password name=cp_verify value="" size=20></td>
      </tr>
      <tr>
        <td align=center colspan=2><input type=submit value="Submit" name="plugin_change_ldappass"></td>
      </tr>
    </table>
</td></tr>
</tr></table>
</body></html>
<?php

function change_ldappass_check($debug = 0) {
   global $cp_oldpass, $cp_newpass, $cp_verify, $key, $onetimepad;
   global $plugin_change_ldappass;

   $Messages = array();
   $password = OneTimePadDecrypt($key, $onetimepad);

   if ($cp_oldpass == "")
       array_push($Messages, 'You must type in your old password.');
   if ($cp_newpass == "")
       array_push($Messages, 'You must type in a new password.');
   if ($cp_verify == "")
       array_push($Messages,
           'You must also type in your new password in the verify box.');
   if ($cp_newpass != '' && $cp_verify != $cp_newpass)
       array_push($Messages,
           'Your new password doesn\'t match the verify password.');
   if ($cp_oldpass != '' && $cp_oldpass != $password)
       array_push($Messages, 'Your old password is not correct.');

   if (count($Messages))
       return $Messages;

   return change_ldappass_go($password, $debug);
}


function change_ldappass_go($password, $debug) {
		global $username, $base_uri;
		global $cp_newpass, $key, $onetimepad;
		include("../plugins/change_ldappass/config.php");

    $Messages = array();

    if ($debug)
        array_push($Messages, "Connecting to LDAP Server");

 		$ds=ldap_connect($ldap_server);
 		if (! $ds) {
			array_push($Messages,'Can\'t connect to Directory Server, please try later!');
	 		return $Messages;
 		}

		$r=ldap_bind($ds,$ldap_manager_dn,$ldap_manager_pw);
		$sr=ldap_search($ds,$ldap_base_dn, "uid=$username"); //why do we check the original pass again? Tight security, that's why.

		if (ldap_count_entries($ds,$sr)!=1) {																//make sure we only have 1 uid
	 		array_push($Messages,'Duplicate login entries detected, cannot change password!');
	 		return $Messages;
		}

		$info = ldap_get_entries($ds, $sr);
		$lpass=$info[0][$ldap_password_field][0];
		$cpass=crypt($password,substr($lpass,7,2));
		$dn=$info[0]["dn"];

		if ($lpass!="{crypt}$cpass") {
			array_push($Messages,'Your old password is not correct.');
			return $Messages;
		}

		$newpass="{crypt}".crypt($cp_newpass);
		$newinfo[$ldap_password_field]=$newpass;
		if (ldap_modify($ds,$dn,$newinfo)) {
			$smb=0;
			if ($change_smb) {
				$exe="echo \"$password\" |$smb_passwd -U $username -s \"$cp_newpass\" 2>&1";
				if ($debug) array_push($Messages,$exe);
				$r=exec($exe,$s);
				if ($r=="Password changed for user $username") $smb=1;
			} else {
				$smb=1;
			}
			if ($smb) {
				if ($debug) array_push($Messages, 'Password changed successfully.');
				// Write new cookies for the password
				$onetimepad = OneTimePadCreate(strlen($cp_newpass));
				$key = OneTimePadEncrypt($cp_newpass, $onetimepad);
				setcookie("key", $key, 0, $base_uri);
				// Automatically forward back to the options screen if correct
				if ($debug == 0) {
					header("Location: $base_uri/src/options.php?plugin_change_ldappass=true");
					exit(0);
				}
				return $Messages;
			} else { //smbpasswd change failed so we must re sync the ldap password back to its original
				$newinfo["userpassword"]=$lpass;
				$r=ldap_modify($ds,$dn,$newinfo);  //change it back so  they're not out of sync.
				array_push($Messages,'SMB Password change was not successful!');
				return $Messages;
			}
		} else {
			array_push($Messages,'LDAP Password change was not successful!');
			return $Messages;
		}
		@ldap_close($ds);
}

?>
