<?php
   /*
    *  Mail Fetch
    *
    */

   chdir ("..");
   include('../src/validate.php');
   include ("../functions/page_header.php");
   include ("../functions/imap.php");
   include ("../src/load_prefs.php");
   include ("../plugins/mail_fetch/class.POP3.php3");


function Mail_Fetch_Status($msg)
{
    echo htmlspecialchars($msg) . "<br>\n";
    flush();
}


   displayPageHeader($color, "None");

   $mailfetch_server_number = getPref($data_dir, $username, "mailfetch_server_number");
   if (!isset($mailfetch_server_number)) $mailfetch_server_number=0;
   if ($mailfetch_server_number<1) $mailfetch_server_number=0;
   for ($i=0;$i<$mailfetch_server_number;$i++) {
         $mailfetch_server_[$i] = getPref($data_dir, $username, "mailfetch_server_$i");
         $mailfetch_user_[$i] = getPref($data_dir, $username, "mailfetch_user_$i");
         $mailfetch_pass_[$i] = getPref($data_dir, $username, "mailfetch_pass_$i");
         $mailfetch_lmos_[$i] = getPref($data_dir, $username, "mailfetch_lmos_$i");
         $mailfetch_login_[$i] = getPref($data_dir, $username, "mailfetch_login_$i");
         $mailfetch_uidl_[$i] = getPref($data_dir, $username, "mailfetch_uidl_$i");
         $mailfetch_subfolder_[$i] = getPref($data_dir, $username, "mailfetch_subfolder_$i");
   }

   if (!isset($server_to_fetch)) {
        ?>
        <BR>
        <TABLE WIDTH=95% COLS=1 ALIGN=CENTER>
           <TR><TD BGCOLOR="<? echo $color[0] ?>" ALIGN=CENTER><b>Remote POP server Fetching Mail</b></TD></TR>
        </TABLE><font size=-5><BR></font>
        <form action="<? echo $PHP_SELF; ?>" METHOD="GET" TARGET=_self>
        <TABLE WIDTH=70% COLS=2 ALIGN=CENTER>
           <TR>
               <TD ALIGN=RIGHT>Select Server: &nbsp; &nbsp; </TD>
               <TD><SELECT NAME=server_to_fetch SIZE=1><?
                   echo "<OPTION VALUE=\"all\" SELECTED>..All..\n";
                   for ($i=0;$i<$mailfetch_server_number;$i++) {
                         echo "<OPTION VALUE=\"$i\">$mailfetch_server_[$i]\n";
                   } ?></SELECT>
               </TD>
           </TR>
           <?
           //if password not set, ask for it
           for ($i=0;$i<$mailfetch_server_number;$i++) {
                 if ($mailfetch_pass_[$i]=="") {
                      echo "\t<tr>\n";
                      echo "\t\t<TD ALIGN=RIGHT>Password for <B>$mailfetch_server_[$i]</B>: &nbsp; &nbsp; </TD>\n";
                      echo "\t\t<TD><INPUT TYPE=PASSWORD NAME=pass_$i></TD>\n";
                      echo "\t</TR>";
                 }
           }
           ?>
           <TR>
               <TD>&nbsp;</TD>
               <TD><input type=submit name=submit_mailfetch value="Fetch Mail"></TD>
           </TR>
        </TABLE>
        </form>
        <?
        exit();
   }

   if ($server_to_fetch=="all") {
        $i_start=0;
        $i_stop=$mailfetch_server_number;
   } else {
        $i_start=$server_to_fetch;
        $i_stop=$i_start+1;
   }

   for ($i_loop=$i_start;$i_loop<$i_stop;$i_loop++) {
         $mailfetch_server=$mailfetch_server_[$i_loop];
         $mailfetch_user=$mailfetch_user_[$i_loop];
         if ($mailfetch_pass_[$i_loop]=="") {
              $tmp="pass_$i_loop";
              $mailfetch_pass=$$tmp;
         } else {
              $mailfetch_pass=$mailfetch_pass_[$i_loop];
         }
         $mailfetch_lmos=$mailfetch_lmos_[$i_loop];
         $mailfetch_login=$mailfetch_login_[$i_loop];
         $mailfetch_uidl=$mailfetch_uidl_[$i_loop];
         $mailfetch_subfolder=$mailfetch_subfolder_[$i_loop];


         $pop3 = new POP3($mailfetch_server, 60);

         echo "<h1>Fetching from $mailfetch_server</h1>\n";
         echo "<p>";
         flush();

         if (!$pop3->connect($mailfetch_server)) {
               Mail_Fetch_Status("Ooops,  $pop3->ERROR");
               continue;
         }

         Mail_Fetch_Status("Opening IMAP server");
         $imap_stream = sqimap_login($username, $key, $imapServerAddress, $imapPort, 10);

         Mail_Fetch_Status("Opening POP server");
         $Count = $pop3->login($mailfetch_user, $mailfetch_pass);
         if (($Count == false || $Count == -1) && $pop3->ERROR != '') {
               Mail_Fetch_Status("Login Failed: $pop3->ERROR");
               continue;
         }

         //   register_shutdown_function($pop3->quit());

         $msglist = $pop3->uidl();

         $i = 1;
         for ($j = 1; $j < sizeof($msglist); $j++) {
               if ($msglist["$j"] == $mailfetch_uidl) {
                    $i = $j+1;
                    break;
               }
         }

         if ($Count < $i) {
              Mail_Fetch_Status("Login OK: No new messages");
              $pop3->quit();
              continue;
         }
         if ($Count == 0) {
              Mail_Fetch_Status("Login OK: Inbox EMPTY");
              $pop3->quit();
              continue;
         } else {
              $newmsgcount = $Count - $i + 1;
              Mail_Fetch_Status("Login OK: Inbox contains [$newmsgcount] messages");
         }

         Mail_Fetch_Status("Fetching UIDL...");
         // Faster to get them all at once
         $mailfetch_uidl = $pop3->uidl();

         if (! is_array($mailfetch_uidl) && $mailfetch_lmos == 'on')
         {
            Mail_Fetch_Status("Server does not support UIDL.");
         }
         if ($mailfetch_lmos == "on") {
              Mail_Fetch_Status("Leaving Mail on Server...");
         } else {
              Mail_Fetch_Status("Deleting messages from server...");
         }

         for (; $i <= $Count; $i++) {
              Mail_Fetch_Status("Fetching message $i");
	      set_time_limit(20); // 20 seconds per message max
              $Message = "";
              $MessArray = $pop3->get($i);

              if ( (!$MessArray) or (gettype($MessArray) != "array")) {
                      Mail_Fetch_Status("oops, $pop3->ERROR");
                      continue 2;
              }

              while (list($lineNum, $line) = each ($MessArray)) {
                     $Message .= $line;
              }

              if ($mailfetch_subfolder=="") {
                   fputs($imap_stream, "A3$i APPEND INBOX {" . (strlen($Message) - 1) . "}\r\n");
              } else {
                   fputs($imap_stream, "A3$i APPEND $mailfetch_subfolder {" . (strlen($Message) - 1) . "}\r\n");
              }
              $Line = fgets($imap_stream, 1024);
              if (substr($Line, 0, 1) == '+') {
                  fputs($imap_stream, $Message);
                  sqimap_read_data($imap_stream, "A3$i", false, $response, $message);
                  Mail_Fetch_Status("Message appended to mailbox");

                  if ($mailfetch_lmos != "on") {
                       $pop3->delete($i);
                       Mail_Fetch_Status("Message deleted from Remote Server!");
                  }
              } else {
                  echo "$Line";
                  Mail_Fetch_Status("Error Appending Message!");
              }
         }

         Mail_Fetch_Status("Closing POP");
         Mail_Fetch_Status("Logging out from IMAP");
         sqimap_logout($imap_stream);
         if (is_array($mailfetch_uidl)) {
             Mail_Fetch_Status("Saving UIDL");
             setPref($data_dir,$username,"mailfetch_uidl_$i_loop",
                     array_pop($mailfetch_uidl));
         }

         Mail_Fetch_Status("Done");
         echo "</p>";

   }

?>
