<?php

function squirrelmail_plugin_init_mail_fetch() {
  global $squirrelmail_plugin_hooks;
  global $mailbox, $imap_stream, $imapConnection;

  $squirrelmail_plugin_hooks['menuline']['mail_fetch'] = 'mail_fetch_link';
  $squirrelmail_plugin_hooks["options_save"]["mail_fetch"] = "mail_fetch_save_pref";
  $squirrelmail_plugin_hooks["loading_prefs"]["mail_fetch"] = "mail_fetch_load_pref";
  $squirrelmail_plugin_hooks["options_link_and_description"]["mail_fetch"] = "mail_fetch_opt";
  $squirrelmail_plugin_hooks["login_verified"]["mail_fetch"] = "mail_fetch_login";

}

function mail_fetch_link() {
  displayInternalLink('plugins/mail_fetch/fetch.php', 'Fetch', '');
  echo '&nbsp;&nbsp;';
}

function mail_fetch_opt() {
  global $color;
  ?>
  <table width=50% cellpadding=3 cellspacing=0 border=0 align=center>
  <tr>
     <td bgcolor="<?php echo $color[9] ?>">
       <a href="../plugins/mail_fetch/options.php">Simple POP3 Fetch Mail</a>
     </td>
  </tr>
  <tr>
     <td bgcolor="<?php echo $color[0] ?>">
        This configures settings for downloading email from a pop3
        mailbox to your account on this server.
     </td>
  </tr>
  </table>
  <?php
}

function mail_fetch_load_pref() {

  global $username,$data_dir;
  global $mailfetch_server_number;
  global $mailfetch_server_,$mailfetch_user_,$mailfetch_pass_;
  global $mailfetch_lmos_, $mailfetch_uidl_, $mailfetch_login_;

  $mailfetch_server_number = getPref($data_dir, $username, "mailfetch_server_number");
  if (!isset($mailfetch_server_number)) $mailfetch_server_number=0;
  if ($mailfetch_server_number<1) $mailfetch_server_number=0;
  for ($i=0;$i<$mailfetch_server_number;$i++) {
      $mailfetch_server_[$i] = getPref($data_dir, $username, "mailfetch_server_$i");
      $mailfetch_user_[$i] = getPref($data_dir, $username, "mailfetch_user_$i");
      $mailfetch_pass_[$i] = getPref($data_dir, $username, "mailfetch_pass_$i");
      $mailfetch_lmos_[$i] = getPref($data_dir, $username, "mailfetch_lmos_$i");
      $mailfetch_login_[$i] = getPref($data_dir, $username, "mailfetch_login_$i");
      $mailfetch_uidl_[$i] = getPref($data_dir, $username, "mailfetch_uidl_$i");
  }
}

function mail_fetch_save_pref() {
  global $username,$data_dir;
  global $mf_server, $mf_user, $mf_pass, $mf_lmos;
  global $mf_uidl;
  global $mf_login, $submit_mailfetch;
  global $mf_action, $mf_sn, $mf_subfolder;

  if (isset($submit_mailfetch)) {
      if ($mf_action=="add") {
           //add new server
           if ($mf_sn<1) $mf_sn=0;
           if (!isset($mf_server)) return;
           setPref($data_dir,$username,"mailfetch_server_$mf_sn", (isset($mf_server)?$mf_server:""));
           setPref($data_dir,$username,"mailfetch_user_$mf_sn",(isset($mf_user)?$mf_user:""));
           setPref($data_dir,$username,"mailfetch_pass_$mf_sn",(isset($mf_pass)?$mf_pass:""));
           setPref($data_dir,$username,"mailfetch_lmos_$mf_sn",(isset($mf_lmos)?$mf_lmos:""));
           setPref($data_dir,$username,"mailfetch_login_$mf_sn",(isset($mf_login)?$mf_login:""));
           setPref($data_dir,$username,"mailfetch_subfolder_$mf_sn",(isset($mf_subfolder)?$mf_subfolder:""));
           $mf_sn++;
           setPref($data_dir,$username,"mailfetch_server_number", $mf_sn);
      } elseif ($mf_action=="confirm_modify") {
           //modify a server
           if (!isset($mf_server)) return;
           setPref($data_dir,$username,"mailfetch_server_$mf_sn", (isset($mf_server)?$mf_server:""));
           setPref($data_dir,$username,"mailfetch_user_$mf_sn",(isset($mf_user)?$mf_user:""));
           setPref($data_dir,$username,"mailfetch_pass_$mf_sn",(isset($mf_pass)?$mf_pass:""));
           setPref($data_dir,$username,"mailfetch_lmos_$mf_sn",(isset($mf_lmos)?$mf_lmos:""));
           setPref($data_dir,$username,"mailfetch_login_$mf_sn",(isset($mf_login)?$mf_login:""));
           setPref($data_dir,$username,"mailfetch_subfolder_$mf_sn",(isset($mf_subfolder)?$mf_subfolder:""));
      } elseif ($mf_action=="confirm_delete") {
           //delete a server
           $mailfetch_server_number = getPref($data_dir, $username, "mailfetch_server_number");
           if ($mf_sn+1==$mailfetch_server_number) {
                //is the last server, whe can only decrase $mailfetch_server_number
                $mailfetch_server_number--;
                setPref($data_dir,$username,"mailfetch_server_number", $mailfetch_server_number);
           } else {
                //if not the last, all the sequel server come up one step
                //then whe decrase $mailfetch_server_number
                $mailfetch_server_number--;
                for ($i=$mf_sn;$i<$mailfetch_server_number;$i++) {
                      $tmp=$i+1;
                      setPref($data_dir,$username,"mailfetch_server_$mf_sn", getPref($data_dir, $username, "mailfetch_server_$tmp"));
                      setPref($data_dir,$username,"mailfetch_user_$mf_sn", getPref($data_dir, $username, "mailfetch_user_$tmp"));
                      setPref($data_dir,$username,"mailfetch_pass_$mf_sn", getPref($data_dir, $username, "mailfetch_pass_$tmp"));
                      setPref($data_dir,$username,"mailfetch_lmos_$mf_sn", getPref($data_dir, $username, "mailfetch_lmos_$tmp"));
                      setPref($data_dir,$username,"mailfetch_login_$mf_sn", getPref($data_dir, $username, "mailfetch_login_$tmp"));
                      setPref($data_dir,$username,"mailfetch_subfolder_$mf_sn", getPref($data_dir, $username, "mailfetch_subfolder_$tmp"));
                }
                setPref($data_dir,$username,"mailfetch_server_number", $mailfetch_server_number);
           }
      }
  }
}

function mail_fetch_login() {
//  echo "Checking mail on login...";
}
?>