<?php

    chdir('..');
    include ('../src/validate.php');
    include ('../src/load_prefs.php');
    include ('../functions/imap.php');
    include ('../functions/page_header.php');
    
    displayPageHeader($color, $mailbox);

    $imap_stream = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);
    sqimap_mailbox_select($imap_stream, $mailbox);
    fputs($imap_stream, 'a010 FETCH ' . $passed_id . ' RFC822' . "\r\n");
    $read = sqimap_read_data($imap_stream, 'a010', true, $response, $message);
    array_shift($read);

    if (!isset($attachments))
    {
       $attachments = array();
       session_register('attachments');
    }
    
    foreach ($attachments as $info) {
       if (file_exists($attachment_dir . $info['localfilename']))
          unlink($attachment_dir . $info['localfilename']);
    }
    $attachments = array();

    $file = GenerateRandomString(32, '', 7);
    while (file_exists($attachment_dir . $file))
        $file = GenerateRandomString(32, '', 7);
    $newAttachment['localfilename'] = $file;
    $newAttachment['remotefilename'] = 'email.txt';
    $newAttachment['type'] = 'message/rfc822';
    $fp = fopen($attachment_dir . $file, 'w');
    foreach ($read as $line) {
       fputs($fp, $line);
    }
    $attachments[] = $newAttachment;
    
    $identity = getPref($data_dir, $username, 'spamcop_identity');
    if ($identity == '')
       $identity = 'default';
    if ($identity == 'default')
       $post = '';
    else
       $post = $identity;
    $fn = getPref($data_dir, $username, 'full_name' . $post);
    $em = getPref($data_dir, $username, 'email_address' . $post);
    
    $HowItLooks = $fn . ' ';
    if ($em != '')
       $HowItLooks .= '<' . $em . '>';

?>

<p>Sending this spam report will give you back a reply with URLs that you
can click on to properly report this spam message to the proper authorities.
This is a free service.  By pressing the "Send Spam Report" button, you
agree to follow SpamCop's rules/terms of service/etc.</p>

<table align=center width="75%" border=0 cellpadding=0 cellspacing=0>
<tr>
<td colspan=2 align=center>
   <b>Spam report will be sent as:</b><br>
   <?PHP echo htmlspecialchars($HowItLooks) ?>
</td>
</tr>
<tr>
<td colspan=2>
   &nbsp;
</td>
</tr>
<tr>
<td align=left valign=top>
  <form method=post action="../../src/right_main.php">
  <input type=hidden name="mailbox" value=<?PHP echo
     htmlspecialchars($mailbox) ?>">
  <input type=submit value="Cancel">
  </form>
</td>
<td align=right valign=top>
  <form method=post action="../../src/compose.php">
  <input type=hidden name="mailbox" value="<?PHP echo
     htmlspecialchars($mailbox) ?>">
  <input type=hidden name="spamcop_id" value="<?PHP echo
     htmlspecialchars($passed_id) ?>">
  <input type=hidden name="send_to" value="spamcop@spamcop.net">
  <input type=hidden name="send_to_cc" value="">
  <input type=hidden name="send_to_bcc" value="">
  <input type=hidden name="subject" value="reply anyway">
  <input type=hidden name="from_htmladdr_search" value="1">
  <input type=hidden name="identity" value="<?PHP echo
     htmlspecialchars($identity) ?>">
  <input type=submit name="send" value="Send Spam Report">
  </form>
</td>
</tr>
</table>
  </body>
</html>
