<?php
/**
    LOGINCHECK MODULE
    ------------------
    Checks whatever the admin typed into the password field at the
    previous screen and makes sure it's something useful and not
    some garbage.
    								**/
								
global $AUTHCODE, $vdomain, $vsecret, $VADMIN_CROSS_ADMIN_AUTH_METHOD;

// make sure nobody is trying to be nasty by hand-coding the admin domain
// names before we authorize it.
if ($AUTHCODE=="LOGIN"){
 $myhost = vadmin_host_walk();
 if ($vdomain!=$myhost) vadmin_security_breach();
}

if ($AUTHCODE=="CROSS"){
 // make sure this domain is actually in the list of domains in his
 // name.
 $domain_list = file("$VADMIN_DIR/cross-admins/$username");
 @array_walk($domain_list, 'vadmin_trim_array');
 if (!in_array($vdomain, $domain_list)) vadmin_security_breach();
}

if ($AUTHCODE=="CROSS" || $AUTHCODE=="ELVIS"){
 // now make sure this domain is setup in $VADMIN_DIR
 // otherwise vadmin will barf. They should set up their domains,
 // really!
 if (!file_exists("$VADMIN_DIR/$vdomain")) vadmin_switch_module("loginsetdom");
}

// kill magic quotes

if ($AUTHCODE=="LOGIN" || $VADMIN_CROSS_ADMIN_AUTH_METHOD=="USER"){
 global $key, $onetimepad;
 $clear_key = OneTimePadDecrypt($key, $onetimepad);
 if ($vsecret == $clear_key){
  // Ok! Now check to see whether we have passwd file for this
  // domain.
  $vsecret=vadmin_get_domain_passwd($vdomain);
  if (!$vsecret){
   // Nope. Since it makes no sense to work in AUTH_METHOD="USER"
   // without a stored password, load the askpasswd module.
   vadmin_switch_module("loginaskpasswd");
  }
 } else {
  vadmin_userError("The password you provided is incorrect.");
 }
}

global $VADMIN_AUTHCODE, $VADMIN_SECRET;
session_register('VADMIN_AUTHCODE');
session_register('VADMIN_SECRET');

// Try to verify domain password by getting a domain listing with the
// provided vdomain and vsecret. At the same time this checks whether a
// stored password is correct.
if ($reply=vadmin_domain_passwd_isbad($vdomain, $vsecret)){
 // see if we need to unlink the file.
 if ($AUTHCODE=="LOGIN" || $VADMIN_CROSS_ADMIN_AUTH_METHOD=="USER"){
  // stored password is invalid!
  // remove it.
  vadmin_unlink_file("$VADMIN_DIR/$vdomain/passwd");
  vadmin_systemError("The stored password file was invalid and has been
  removed. You will need to log in again.");
 }
 vadmin_userError($reply);
}

$AUTHCODE=$vdomain;
// set the session data, encrypting it before sticking into the
// apache-readable /tmp/.sess*. The things I do out of my
// paranoia.. ;)
$VADMIN_AUTHCODE=vadmin_crypto($vdomain, "encrypt");
$VADMIN_SECRET=vadmin_crypto($vsecret, "encrypt");

vadmin_switch_module("mainmenu");
?>
